searchable.searchsequence

## Class SearchSequenceWithOrderedSelect

- java.lang.Object
- - searchable.searchsequence.SearchSequence
  - - searchable.searchsequence.SearchSequenceWithOrderedSelect

- All Implemented Interfaces:
    Searchable, SearchableWithMedian
  Direct Known Subclasses:
    OrderedSearchSequence, SortedSearchSequence

      abstract class SearchSequenceWithOrderedSelect
      extends SearchSequence
      implements SearchableWithMedian

  Pomocná třída, která doplňuje SearchSequence o metodu orderedSelect.

  Popis: Metoda orderedSelect prohledává uspořádané posloupnosti.

  Užití: Instance této třídy nepoužívejte v aplikacích. Využije se v uspořádaných a seřazených vyhledávacích posloupnostech.

- - ### Field Summary

    - ### Fields inherited from class searchable.searchsequence.SearchSequence

      `sequence`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SearchSequenceWithOrderedSelect(Sequence aSequence)` Vyrobí instanci vyhledávací posloupnosti SearchSequenceWithOrderedSelect.
    `SearchSequenceWithOrderedSelect(SequenceFactory aSequenceFactory, int aSize)` Vyrobí instanci vyhledávací posloupnosti SearchSequenceWithOrderedSelect.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected SearchableElement` | `orderedSelect(SearchableElement key)` V uspořádané posloupnosti najde podle zadaného klíče hledaný nebo první následující prvek.
    `SearchableElement` | `select(SearchableElement key)` Najde prvek posloupnosti podle klíče.
    `abstract SearchableElement` | `selectMedian()` Najde medián.
    `SearchableElement` | `update(SearchableElement elem)` Najde a upraví nebo nenajde a vloží prvek vyhledávací struktury.

    - ### Methods inherited from class searchable.searchsequence.SearchSequence

      `getCount, getOperationCounter, getReadable, getSortCounter, insert, isEmpty, isFull, remove, setSequence`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface searchable.searchableinterface.Searchable

      `getCount, getOperationCounter, getReadable, getSortCounter, insert, isEmpty, isFull, remove`

- - ### Constructor Detail

    - #### SearchSequenceWithOrderedSelect

          public SearchSequenceWithOrderedSelect(SequenceFactory aSequenceFactory,
                                                 int aSize)

      Vyrobí instanci vyhledávací posloupnosti SearchSequenceWithOrderedSelect.

      Popis: inicializuje atributy instance.

      Užití: zejména ve factory.

      Parameters:
        `aSequenceFactory` - továrna na posloupnosti
        `aSize` - požadovaná kapacita posloupnosti

    - #### SearchSequenceWithOrderedSelect

          public SearchSequenceWithOrderedSelect(Sequence aSequence)

      Vyrobí instanci vyhledávací posloupnosti SearchSequenceWithOrderedSelect.

      Popis: inicializuje atributy instance.

      Užití: volejte z konstruktorů odvozených tříd (dědiců).

      Parameters:
        `aSequence` - posloupnost, která se má prohledávat

  - ### Method Detail

    - #### orderedSelect

          protected SearchableElement orderedSelect(SearchableElement key)

      V uspořádané posloupnosti najde podle zadaného klíče hledaný nebo první následující prvek.

      Vyžaduje: posloupnost sequence musí být seřazena vzestupně.

      Parameters:
        `key` - klíč prvku, který se má najít
      Returns:
        nalezený prvek nebo null, když se hledaný prvek nenašel

    - #### select

          public SearchableElement select(SearchableElement key)

      Najde prvek posloupnosti podle klíče.

      Vyžaduje: posloupnost sequence musí být seřazena vzestupně.

      Specified by:
        `select` in interface `Searchable`
      Overrides:
        `select` in class `SearchSequence`
      Parameters:
        `key` - klíč
      Returns:
        nalezený prvek nebo null

    - #### update

          public SearchableElement update(SearchableElement elem)

      Description copied from interface: `Searchable`
      Najde a upraví nebo nenajde a vloží prvek vyhledávací struktury.
      Specified by:
        `update` in interface `Searchable`
      Overrides:
        `update` in class `SearchSequence`
      Parameters:
        `elem` - prvek, který se má upravit nebo vložit
      Returns:
        odstraněný původní prvek nebo null

    - #### selectMedian

          public abstract SearchableElement selectMedian()

      Description copied from interface: `SearchableWithMedian`
      Najde medián. Medián je prostřední prvek z posloupnosti nebo jiné uspořádané struktury. V případě sudého počtu prvků není výsledek jednoznačný - je lhostejné, který se najde.
      Specified by:
        `selectMedian` in interface `SearchableWithMedian`
      Returns:
        medián